{
    "$graph": [
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/column"
                },
                {
                    "type": "File",
                    "id": "#main/config"
                },
                {
                    "type": "float",
                    "id": "#main/dec"
                },
                {
                    "type": "string",
                    "id": "#main/dfreq"
                },
                {
                    "type": "int",
                    "id": "#main/dtime"
                },
                {
                    "type": "float",
                    "id": "#main/fov"
                },
                {
                    "type": "float",
                    "id": "#main/freq0"
                },
                {
                    "type": "float",
                    "id": "#main/mgain"
                },
                {
                    "type": "int",
                    "id": "#main/nchan"
                },
                {
                    "type": "int",
                    "id": "#main/niter"
                },
                {
                    "type": "int",
                    "id": "#main/nsrc"
                },
                {
                    "type": "float",
                    "id": "#main/pb_fwhm"
                },
                {
                    "type": "float",
                    "id": "#main/ra"
                },
                {
                    "type": "int",
                    "id": "#main/random_seed"
                },
                {
                    "type": "string",
                    "id": "#main/scale"
                },
                {
                    "type": "int",
                    "id": "#main/size_x"
                },
                {
                    "type": "int",
                    "id": "#main/size_y"
                },
                {
                    "type": "float",
                    "id": "#main/synthesis"
                },
                {
                    "type": "string",
                    "id": "#main/telescope"
                }
            ],
            "steps": [
                {
                    "run": "#random_sky.cwl",
                    "in": [
                        {
                            "source": "#main/dec",
                            "id": "#main/make_skymodel/dec"
                        },
                        {
                            "source": "#main/fov",
                            "id": "#main/make_skymodel/fov"
                        },
                        {
                            "source": "#main/freq0",
                            "id": "#main/make_skymodel/freq0"
                        },
                        {
                            "source": "#main/nsrc",
                            "id": "#main/make_skymodel/nsrc"
                        },
                        {
                            "source": "#main/pb_fwhm",
                            "id": "#main/make_skymodel/pb_fwhm"
                        },
                        {
                            "source": "#main/ra",
                            "id": "#main/make_skymodel/ra"
                        },
                        {
                            "source": "#main/random_seed",
                            "id": "#main/make_skymodel/seed"
                        }
                    ],
                    "out": [
                        "#main/make_skymodel/skymodel"
                    ],
                    "id": "#main/make_skymodel"
                },
                {
                    "run": "#simms.cwl",
                    "in": [
                        {
                            "source": "#main/dec",
                            "id": "#main/simms/dec"
                        },
                        {
                            "source": "#main/dfreq",
                            "id": "#main/simms/dfreq"
                        },
                        {
                            "source": "#main/dtime",
                            "id": "#main/simms/dtime"
                        },
                        {
                            "source": "#main/freq0",
                            "id": "#main/simms/freq0"
                        },
                        {
                            "source": "#main/nchan",
                            "id": "#main/simms/nchan"
                        },
                        {
                            "source": "#main/ra",
                            "id": "#main/simms/ra"
                        },
                        {
                            "source": "#main/synthesis",
                            "id": "#main/simms/synthesis"
                        },
                        {
                            "source": "#main/telescope",
                            "id": "#main/simms/telescope"
                        }
                    ],
                    "out": [
                        "#main/simms/ms"
                    ],
                    "id": "#main/simms"
                },
                {
                    "run": "#simulator.cwl",
                    "in": [
                        {
                            "source": "#main/config",
                            "id": "#main/simulator/config"
                        },
                        {
                            "source": "#main/simms/ms",
                            "id": "#main/simulator/ms"
                        },
                        {
                            "source": "#main/column",
                            "id": "#main/simulator/output_column"
                        },
                        {
                            "source": "#main/make_skymodel/skymodel",
                            "id": "#main/simulator/skymodel"
                        }
                    ],
                    "out": [
                        "#main/simulator/ms_out"
                    ],
                    "id": "#main/simulator"
                },
                {
                    "run": "#tigger_restore.cwl",
                    "in": [
                        {
                            "source": "#main/wsclean/dirty",
                            "id": "#main/tigger_restore/image"
                        },
                        {
                            "source": "#main/make_skymodel/skymodel",
                            "id": "#main/tigger_restore/skymodel"
                        }
                    ],
                    "out": [
                        "#main/tigger_restore/fitsmodel"
                    ],
                    "id": "#main/tigger_restore"
                },
                {
                    "run": "#wsclean.cwl",
                    "in": [
                        {
                            "source": "#main/column",
                            "id": "#main/wsclean/column"
                        },
                        {
                            "source": "#main/mgain",
                            "id": "#main/wsclean/mgain"
                        },
                        {
                            "source": "#main/simulator/ms_out",
                            "id": "#main/wsclean/ms"
                        },
                        {
                            "source": "#main/niter",
                            "id": "#main/wsclean/niter"
                        },
                        {
                            "source": "#main/scale",
                            "id": "#main/wsclean/scale"
                        },
                        {
                            "source": "#main/size_x",
                            "id": "#main/wsclean/size_x"
                        },
                        {
                            "source": "#main/size_y",
                            "id": "#main/wsclean/size_y"
                        }
                    ],
                    "out": [
                        "#main/wsclean/cleaned",
                        "#main/wsclean/dirty",
                        "#main/wsclean/residual",
                        "#main/wsclean/model"
                    ],
                    "id": "#main/wsclean"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/wsclean/cleaned",
                    "id": "#main/cleaned"
                },
                {
                    "type": "File",
                    "outputSource": "#main/wsclean/dirty",
                    "id": "#main/dirty"
                },
                {
                    "type": "File",
                    "outputSource": "#main/tigger_restore/fitsmodel",
                    "id": "#main/fitsmodel"
                },
                {
                    "type": "File",
                    "outputSource": "#main/wsclean/model",
                    "id": "#main/model"
                },
                {
                    "type": "File",
                    "outputSource": "#main/wsclean/residual",
                    "id": "#main/residual"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/simulator/ms_out",
                    "id": "#main/simulated_vis"
                },
                {
                    "type": "File",
                    "outputSource": "#main/make_skymodel/skymodel",
                    "id": "#main/skymodel"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "python",
            "hints": [
                {
                    "dockerImageId": "gijzelaerr/spiel",
                    "class": "DockerRequirement"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "\nimport numpy.random as random\n\nra = $( inputs.ra )\ndec = $( inputs.dec )\nseed = $( inputs.seed )\nfov = $( inputs.fov ) \nnsrc = $( inputs.nsrc )\npb_fwhm = $( inputs.pb_fwhm )\nfreq0 = $( inputs.freq0 )\n\nfluxes = random.pareto(5, nsrc) / 100 \n\nif pb_fwhm:\n# Simulate more sources in the primary beam FWHM\n    ras = ra - random.randn(nsrc)*pb_fwhm/2\n    decs = dec - random.randn(nsrc)*pb_fwhm/2\nelse: \n# use uniform distribution in space\n    ras = random.uniform(ra - fov/2.0, ra + fov/2.0, nsrc)\n    decs = random.uniform(dec - fov/2.0, ra + fov/2.0, nsrc)\n    \n# use a spectral index close to -0.7\nspi = -0.7 + random.randn(nsrc)*.01\n\nmodel = open(\"skymodel_{}.txt\".format(seed), \"w\")\n    \nmodel.write(\"#format: name ra_d dec_d i freq0 spi\\\\n\")\nfor i in xrange(nsrc):\n    model.write(\"src{name:04d} {ra:.5g} {dec:.5g} {flux:.3g} {freq0:.5g} {spi:.3f}\\\\n\".format(\n    name=i, ra=ras[i], dec=decs[i], flux=fluxes[i], freq0=freq0, spi=spi[i]))\nmodel.close()\n"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": -30,
                    "id": "#random_sky.cwl/dec"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 1,
                    "id": "#random_sky.cwl/fov"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 1420000000.0,
                    "id": "#random_sky.cwl/freq0"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 100,
                    "id": "#random_sky.cwl/nsrc"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.5,
                    "id": "#random_sky.cwl/pb_fwhm"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0,
                    "id": "#random_sky.cwl/ra"
                },
                {
                    "type": "int",
                    "id": "#random_sky.cwl/seed"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "skymodel_$(inputs.seed).txt"
                    },
                    "id": "#random_sky.cwl/skymodel"
                }
            ],
            "id": "#random_sky.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "simms",
            "requirements": [
                {
                    "class": "EnvVarRequirement",
                    "envDef": [
                        {
                            "envValue": "root",
                            "envName": "USER"
                        }
                    ]
                }
            ],
            "hints": [
                {
                    "dockerImageId": "gijzelaerr/spiel",
                    "class": "DockerRequirement"
                }
            ],
            "arguments": [
                {
                    "prefix": "--ra",
                    "valueFrom": "$(inputs.ra)deg"
                },
                {
                    "prefix": "--dec",
                    "valueFrom": "$(inputs.dec)deg"
                }
            ],
            "inputs": [
                {
                    "type": "float",
                    "doc": "Phase tracking centre of observation",
                    "id": "#simms.cwl/dec"
                },
                {
                    "type": "string",
                    "doc": "Channel width",
                    "inputBinding": {
                        "prefix": "--dfreq"
                    },
                    "id": "#simms.cwl/dfreq"
                },
                {
                    "type": "int",
                    "doc": "Integration time",
                    "inputBinding": {
                        "prefix": "--dtime"
                    },
                    "id": "#simms.cwl/dtime"
                },
                {
                    "type": "float",
                    "doc": "Start frequency of observation",
                    "inputBinding": {
                        "prefix": "--freq0"
                    },
                    "id": "#simms.cwl/freq0"
                },
                {
                    "type": "int",
                    "doc": "Number of channels",
                    "inputBinding": {
                        "prefix": "--nchan"
                    },
                    "id": "#simms.cwl/nchan"
                },
                {
                    "type": "float",
                    "doc": "Phase tracking centre of observation",
                    "id": "#simms.cwl/ra"
                },
                {
                    "type": "float",
                    "doc": "Synthesis time of observation",
                    "inputBinding": {
                        "prefix": "--synthesis-time"
                    },
                    "id": "#simms.cwl/synthesis"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--tel"
                    },
                    "id": "#simms.cwl/telescope"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "*.MS"
                    },
                    "id": "#simms.cwl/ms"
                }
            ],
            "id": "#simms.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "meqtree-pipeliner.py",
            "hints": [
                {
                    "dockerImageId": "gijzelaerr/spiel",
                    "class": "DockerRequirement"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.ms)",
                            "entryname": "$(inputs.skymodel.nameroot)_$(inputs.ms.basename)",
                            "writable": true
                        }
                    ]
                }
            ],
            "arguments": [
                "--mt",
                "$( runtime.cores )",
                "-c",
                "$( inputs.config.path )",
                "[sim]",
                "ms_sel.input_column=$( inputs.input_column )",
                "ms_sel.field_index=$( inputs.field_index )",
                "ms_sel.msname=$(inputs.ms.path)",
                "me.use_smearing=$( inputs.use_smearing )",
                "sim_mode=$( inputs.sim_mode )",
                "noise_stddev=$( inputs.noise_stddev )",
                "ms_sel.ddid_index=$( inputs.ddid_index )",
                "tiggerlsm.filename=$( inputs.skymodel.path )",
                "ms_sel.output_column=$( inputs.output_column )",
                "/usr/lib/python2.7/dist-packages/Cattery/Siamese/turbo-sim.py",
                "=_simulate_MS"
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#simulator.cwl/config"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "id": "#simulator.cwl/ddid_index"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "id": "#simulator.cwl/field_index"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "DATA",
                    "id": "#simulator.cwl/input_column"
                },
                {
                    "type": "Directory",
                    "id": "#simulator.cwl/ms"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.18581724893,
                    "id": "#simulator.cwl/noise_stddev"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "CORRECTED_DATA",
                    "id": "#simulator.cwl/output_column"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "sim only",
                    "id": "#simulator.cwl/sim_mode"
                },
                {
                    "type": "File",
                    "id": "#simulator.cwl/skymodel"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "id": "#simulator.cwl/tiggerskymodel"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "id": "#simulator.cwl/use_smearing"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "*.MS"
                    },
                    "id": "#simulator.cwl/ms_out"
                }
            ],
            "id": "#simulator.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "tigger-restore",
            "hints": [
                {
                    "dockerImageId": "gijzelaerr/spiel",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    },
                    "id": "#tigger_restore.cwl/image"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#tigger_restore.cwl/skymodel"
                }
            ],
            "arguments": [
                "-b 0",
                "--clear",
                {
                    "position": 2,
                    "valueFrom": "skymodel.fits"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "skymodel.fits"
                    },
                    "id": "#tigger_restore.cwl/fitsmodel"
                }
            ],
            "id": "#tigger_restore.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "wsclean",
            "hints": [
                {
                    "dockerImageId": "gijzelaerr/spiel",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "CORRECTED_DATA",
                    "inputBinding": {
                        "prefix": "-data-column"
                    },
                    "id": "#wsclean.cwl/column"
                },
                {
                    "type": "float",
                    "default": 0.95,
                    "inputBinding": {
                        "prefix": "-mgain"
                    },
                    "id": "#wsclean.cwl/mgain"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#wsclean.cwl/ms"
                },
                {
                    "type": "int",
                    "default": 1000,
                    "inputBinding": {
                        "prefix": "-niter"
                    },
                    "id": "#wsclean.cwl/niter"
                },
                {
                    "type": "string",
                    "default": "1asec",
                    "inputBinding": {
                        "prefix": "-scale"
                    },
                    "id": "#wsclean.cwl/scale"
                },
                {
                    "type": "int",
                    "default": 512,
                    "id": "#wsclean.cwl/size_x"
                },
                {
                    "type": "int",
                    "default": 512,
                    "id": "#wsclean.cwl/size_y"
                }
            ],
            "arguments": [
                "-size",
                "$(inputs.size_x)",
                "$(inputs.size_y)",
                {
                    "prefix": "-temp-dir",
                    "valueFrom": "$(runtime.tmpdir)"
                },
                "-no-update-model-required",
                {
                    "prefix": "-name",
                    "valueFrom": "$(inputs.ms.basename)"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.ms.basename)-image.fits"
                    },
                    "id": "#wsclean.cwl/cleaned"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.ms.basename)-dirty.fits"
                    },
                    "id": "#wsclean.cwl/dirty"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.ms.basename)-model.fits"
                    },
                    "id": "#wsclean.cwl/model"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.ms.basename)-residual.fits"
                    },
                    "id": "#wsclean.cwl/residual"
                }
            ],
            "id": "#wsclean.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
